Exception - Crystal 1.20.3

# class Exception

- Exception
- Reference
- Object

##
Overview

Represents errors that occur during application execution.

Exception and its descendants are used to communicate between raise and rescue statements in `begin ... end` blocks. Exception objects carry information about the exception – its type (the exception’s class name), an optional descriptive string, and optional traceback information. Exception subclasses may add additional information.

##
Direct Known Subclasses

- ArgumentError
- Base64::Error
- Channel::ClosedError
- Compress::Deflate::Error
- Compress::Gzip::Error
- Compress::Zip::Error
- Compress::Zlib::Error
- Crypto::Bcrypt::Error
- CSV::Error
- Digest::FinalizedError
- DivisionByZeroError
- Enumerable::EmptyError
- Enumerable::NotFoundError
- File::BadPatternError
- HTTP::FormData::Error
- HTTP::Server::ClientError
- IndexError
- INI::ParseException
- InvalidBigDecimalException
- InvalidByteSequenceError
- IO::Error
- JSON::Error
- KeyError
- MIME::Error
- MIME::Multipart::Error
- NilAssertionError
- NotImplementedError
- OAuth2::Error
- OAuth::Error
- OpenSSL::Error
- OptionParser::Exception
- OverflowError
- Path::Error
- Process::ExitError
- Regex::Error
- RuntimeError
- Sync::Error
- System::Group::NotFoundError
- System::User::NotFoundError
- Time::Error
- Time::Format::Error
- TypeCastError
- URI::Error
- UUID::Error
- XML::Error
- YAML::Error

##
Defined in:

exception.cr

##
Constructors

- .new(message : String | Nil = nil, cause : Exception | Nil = nil)

##
Instance Method Summary

- #backtrace : Array(String)

  Returns any backtrace associated with the exception.

- #backtrace?

  Returns any backtrace associated with the exception if the call stack exists.

- #cause : Exception | Nil

  Returns the previous exception at the time this exception was raised.

- #inspect(io : IO) : Nil

  Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.

- #inspect_with_backtrace(io : IO) : Nil
- #inspect_with_backtrace : String
- #message : String | Nil
- #to_s(io : IO) : Nil

  Appends a short String representation of this object which includes its class name and its object address.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(message : String | Nil = nil, cause : Exception | Nil = nil) #

##
Instance Method Detail

def backtrace : Array(String) #

Returns any backtrace associated with the exception. The backtrace is an array of strings, each containing “0xAddress: Function at File Line Column”.

def backtrace? #

Returns any backtrace associated with the exception if the call stack exists. The backtrace is an array of strings, each containing “0xAddress: Function at File Line Column”.

def cause : Exception | Nil #

Returns the previous exception at the time this exception was raised. This is useful for wrapping exceptions and retaining the original exception information.

def inspect(io : IO) : Nil #
Description copied from class Reference

Appends a String representation of this object which includes its class name, its object address and the values of all instance variables.

    class Person
      def initialize(@name : String, @age : Int32)
      end
    end

    Person.new("John", 32).inspect # => #<Person:0x10fd31f20 @name="John", @age=32>

def inspect_with_backtrace(io : IO) : Nil #
def inspect_with_backtrace : String #
def message : String | Nil #
def to_s(io : IO) : Nil #
Description copied from class Reference

Appends a short String representation of this object which includes its class name and its object address.

    class Person
      def initialize(@name : String, @age : Int32)
      end
    end

    Person.new("John", 32).to_s # => #<Person:0x10a199f20>